View a markdown version of this page

CreateKnowledgeBase - Amazon Quick

CreateKnowledgeBase

Creates a knowledge base from a specified data source. Supported data source connector types include:

  • S3_KNOWLEDGE_BASE – Uses an Amazon S3 bucket as the data source.

  • WEB_CRAWLER – Uses web pages indexed by the built-in web crawler as the data source.

  • GOOGLE_DRIVE – Uses Google Drive as the data source. Supports service account authentication only.

  • SHAREPOINT – Uses SharePoint as the data source. Supports two-legged OAuth only.

  • ONE_DRIVE – Uses OneDrive as the data source. Supports two-legged OAuth only.

Request Syntax

POST /v1/accounts/AwsAccountId/knowledge-bases HTTP/1.1 Content-type: application/json { "AccessControlConfiguration": { "isACLEnabled": boolean }, "DataSourceArn": "string", "Description": "string", "KnowledgeBaseConfiguration": { "templateConfiguration": { "template": JSON value } }, "KnowledgeBaseId": "string", "MediaExtractionConfiguration": { "audioExtractionConfiguration": { "audioExtractionStatus": "string" }, "imageExtractionConfiguration": { "imageExtractionStatus": "string" }, "videoExtractionConfiguration": { "videoExtractionStatus": "string", "videoExtractionType": "string" } }, "Name": "string", "Permissions": [ { "Actions": [ "string" ], "Principal": "string" } ], "PrimaryOwnerArn": "string", "Tags": [ { "Key": "string", "Value": "string" } ] }

URI Request Parameters

The request uses the following URI parameters.

AwsAccountId

The ID of the AWS account that contains the knowledge base.

Length Constraints: Fixed length of 12.

Pattern: [0-9]*

Required: Yes

Request Body

The request accepts the following data in JSON format.

DataSourceArn

The Amazon Resource Name (ARN) of the data source for the knowledge base.

Type: String

Length Constraints: Minimum length of 0. Maximum length of 1284.

Pattern: arn:[a-z0-9-\.]{1,63}:[a-z0-9-\.]{0,63}:[a-z0-9-\.]{0,63}:[a-z0-9-\.]{0,63}:[^/].{0,1023}

Required: Yes

KnowledgeBaseConfiguration

The configuration settings for a knowledge base.

Type: KnowledgeBaseConfiguration object

Required: Yes

KnowledgeBaseId

The unique identifier for the knowledge base.

Type: String

Length Constraints: Minimum length of 1. Maximum length of 1024.

Pattern: [0-9a-zA-Z-_=.+]+

Required: Yes

Name

The name of the knowledge base.

Type: String

Length Constraints: Minimum length of 0. Maximum length of 128.

Pattern: [\p{L}\p{N}][\p{L}\p{N} _\-\.]*

Required: Yes

AccessControlConfiguration

The access control configuration for the knowledge base. If you don't specify this parameter, document-level ACLs are disabled.

Type: AccessControlConfiguration object

Required: No

Description

A description for the knowledge base. If you don't specify a description, the knowledge base is created without one.

Type: String

Length Constraints: Minimum length of 0. Maximum length of 1000.

Pattern: \P{C}*

Required: No

MediaExtractionConfiguration

The configuration for media extraction from knowledge base documents.

Type: MediaExtractionConfiguration object

Required: No

Permissions

A list of resource permissions on the knowledge base. Each entry grants a specified Amazon QuickSight principal either owner or viewer access. If you don't specify permissions, only the primary owner (if provided) receives owner access.

Type: Array of ResourcePermission objects

Array Members: Minimum number of 1 item. Maximum number of 64 items.

Required: No

PrimaryOwnerArn

The Amazon Resource Name (ARN) of the primary owner for the knowledge base. The specified user is always granted owner access, regardless of what is specified in the Permissions field. If you don't specify a primary owner, the knowledge base is created without one.

Type: String

Required: No

Tags

The tags to assign to the knowledge base. If you don't specify tags, the knowledge base is created without tags.

Type: Array of Tag objects

Array Members: Minimum number of 1 item. Maximum number of 200 items.

Required: No

Response Syntax

HTTP/1.1 Status Content-type: application/json { "CreationStatus": "string", "KnowledgeBaseArn": "string", "KnowledgeBaseId": "string", "RequestId": "string" }

Response Elements

If the action is successful, the service sends back the following HTTP response.

Status

The HTTP status of the request.

The following data is returned in JSON format by the service.

CreationStatus

The creation status of the knowledge base.

Type: String

Valid Values: CREATING | UPDATING | ACTIVE | FAILED | DELETING

KnowledgeBaseArn

The Amazon Resource Name (ARN) of the knowledge base.

Type: String

Length Constraints: Minimum length of 0. Maximum length of 1284.

Pattern: arn:[a-z0-9-\.]{1,63}:[a-z0-9-\.]{0,63}:[a-z0-9-\.]{0,63}:[a-z0-9-\.]{0,63}:[^/].{0,1023}

KnowledgeBaseId

The unique identifier for the knowledge base.

Type: String

Length Constraints: Minimum length of 1. Maximum length of 1024.

Pattern: [0-9a-zA-Z-_=.+]+

RequestId

The AWS request ID for this operation.

Type: String

Errors

For information about the errors that are common to all actions, see Common Error Types.

AccessDeniedException

You don't have access to this item. The provided credentials couldn't be validated. You might not be authorized to carry out the request. Make sure that your account is authorized to use the Amazon Quick Sight service, that your policies have the correct permissions, and that you are using the correct credentials.

RequestId

The AWS request ID for this request.

HTTP Status Code: 401

InternalFailureException

An internal failure occurred.

RequestId

The AWS request ID for this request.

HTTP Status Code: 500

InvalidParameterValueException

One or more parameters has a value that isn't valid.

RequestId

The AWS request ID for this request.

HTTP Status Code: 400

InvalidRequestException

You don't have this feature activated for your account. To fix this issue, contact AWS support.

RequestId

The AWS request ID for this request.

HTTP Status Code: 400

LimitExceededException

A limit is exceeded.

RequestId

The AWS request ID for this request.

ResourceType

Limit exceeded.

HTTP Status Code: 409

PreconditionNotMetException

One or more preconditions aren't met.

RequestId

The AWS request ID for this request.

HTTP Status Code: 400

ResourceExistsException

The resource specified already exists.

RequestId

The AWS request ID for this request.

ResourceType

The resource type for this request.

HTTP Status Code: 409

ResourceNotFoundException

One or more resources can't be found.

RequestId

The AWS request ID for this request.

ResourceType

The resource type for this request.

HTTP Status Code: 404

ThrottlingException

Access is throttled.

RequestId

The AWS request ID for this request.

HTTP Status Code: 429

See Also

For more information about using this API in one of the language-specific AWS SDKs, see the following: